题意:一个图有n个点,n条边,定义D(u,v)为u到v的距离,S(u,k)为所有D(u,v)<=k的节点v的集合 有m次询问(0<=k<=2):

1 u k d:将集合S(u,k)的所有节点的权值加d

2 u k:询问集合S(u,k)的所有节点的权值之和

析:把这个图树成两部分,一个是一个环,然后剩下的森林。

这个环可以用拓扑来求,看这个博客吧,讲的非常细了。

http://blog.csdn.net/qq_31759205/article/details/75049074

代码如下:

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include <cstdio>
#include <string>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <cstring>
#include <set>
#include <queue>
#include <algorithm>
#include <vector>
#include <map>
#include <cctype>
#include <cmath>
#include <stack>
#include <sstream>
#include <list>
#include <assert.h>
#include <bitset>
#include <numeric>
#define debug() puts("++++");
#define gcd(a, b) __gcd(a, b)
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define fi first
#define se second
#define pb push_back
#define sqr(x) ((x)*(x))
#define ms(a,b) memset(a, b, sizeof a)
//#define sz size()
#define pu push_up
#define pd push_down
#define cl clear()
#define all 1,n,1
#define FOR(i,x,n) for(int i = (x); i < (n); ++i)
#define freopenr freopen("in.txt", "r", stdin)
#define freopenw freopen("out.txt", "w", stdout)
using namespace std; typedef long long LL;
typedef unsigned long long ULL;
typedef pair<LL, int> P;
const int INF = 0x3f3f3f3f;
const LL LNF = 1e17;
const double inf = 1e20;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int maxn = 1e5 + 10;
const int maxm = 1e6 + 5;
const int mod = 10007;
const int dr[] = {-1, 0, 1, 0};
const int dc[] = {0, -1, 0, 1};
const char *de[] = {"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111", "1000", "1001", "1010", "1011", "1100", "1101", "1110", "1111"};
int n, m;
const int mon[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const int monn[] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
inline bool is_in(int r, int c) {
return r >= 0 && r < n && c >= 0 && c < m;
} struct Edge{
int to, next;
};
Edge edge[maxn<<1];
int head[maxn], cnt;
int in[maxn]; void addEdge(int u, int v){
edge[cnt].to = v;
edge[cnt].next = head[u];
head[u] = cnt++;
++in[v];
} void topsort(){
queue<int> q;
for(int i = 1; i <= n; ++i) if(in[i] == 1) q.push(i);
while(!q.empty()){
int u = q.front(); q.pop();
for(int i = head[u]; ~i; i = edge[i].next){
int v = edge[i].to;
if(in[v] > 1){
--in[v];
if(in[v] == 1) q.push(v);
}
}
}
} int ch[maxn][2], p[maxn], fp[maxn], pos;
int fa[maxn];
int sonL[maxn], sonR[maxn], ssonL[maxn], ssonR[maxn]; void bfs(int s){
queue<int> q;
q.push(s); while(!q.empty()){
int u = q.front(); q.pop();
sonL[u] = ssonL[u] = INF;
sonR[u] = ssonR[u] = 0;
for(int i = head[u]; ~i; i = edge[i].next){
int v = edge[i].to;
if(in[v] > 1 || fa[u] == v) continue;
p[v] = ++pos;
fp[pos] = v;
fa[v] = u;
sonL[u] = min(sonL[u], p[v]);
sonR[u] = max(sonR[u], p[v]);
q.push(v);
}
ssonL[fa[u]] = min(ssonL[fa[u]], sonL[u]);
ssonR[fa[u]] = max(ssonR[fa[u]], sonR[u]);
}
} LL sum[maxn<<2], addv[maxn<<2];
inline void push_up(int rt){ sum[rt] = sum[rt<<1] + sum[rt<<1|1]; }
inline void push_down(int rt, int len){
int l = rt<<1, r = rt<<1|1;
sum[l] += (len - (len>>1)) * addv[rt];
sum[r] += (len>>1) * addv[rt];
addv[l] += addv[rt];
addv[r] += addv[rt];
addv[rt] = 0;
} void update(int L, int R, int val, int l, int r, int rt){
if(L > R) return ;
if(L <= l && r <= R){
sum[rt] += (LL)(r - l + 1) * val;
addv[rt] += val;
return ;
}
if(addv[rt]) pd(rt, r - l + 1);
int m = l + r >> 1;
if(L <= m) update(L, R, val, lson);
if(R > m) update(L, R, val, rson);
pu(rt);
} LL query(int L, int R, int l, int r, int rt){
if(L > R) return 0LL;
if(L <= l && r <= R) return sum[rt];
if(addv[rt]) pd(rt, r - l + 1);
int m = l + r >> 1;
LL ans = 0;
if(L <= m) ans = query(L, R, lson);
if(R > m) ans += query(L, R, rson);
return ans;
} void praper(){
topsort();
for(int u = 1; u <= n; ++u) if(in[u] > 1){
int j = 0;
for(int i = head[u]; ~i; i = edge[i].next){
int v = edge[i].to;
if(in[v] > 1) ch[u][j++] = v;
}
p[u] = ++pos;
fp[pos] = u;
fa[u] = 0;
bfs(u);
}
} void init(){
ms(head, -1); cnt = 0; ms(in, 0);
pos = 0; ms(sum, 0); ms(addv, 0);
} void update(int u, int k, int val){
int f = fa[u];
if(k == 0) update(p[u], p[u], val, all); // self
else if(k == 1){
if(in[u] > 1){ // on the circle
update(p[ch[u][0]], p[ch[u][0]], val, all); // left neighbor
update(p[ch[u][1]], p[ch[u][1]], val, all); // right neighbor
}
else // not on the circle
update(p[f], p[f], val, all); // its father
update(sonL[u], sonR[u], val, all); // left son - right son
update(p[u], p[u], val, all); //self
}
else {
if(in[u] > 1){ // on the circle
int vv[2], cnt = 0;
for(int i = 0; i < 2; ++i){
int v = ch[u][i];
update(p[v], p[v], val, all); // its neighbor
update(sonL[v], sonR[v], val, all); // its neighbor's sons
for(int j = 0; j < 2; ++j){
int t = ch[v][j];
if(t == u || t == ch[u][i^1]) continue; // insure not calculate twice times
if(cnt == 1 && vv[0] == t) continue;
vv[cnt++] = t;
}
}
for(int i = 0; i < cnt; ++i)
update(p[vv[i]], p[vv[i]], val, all); // its neighbor's neighbor
update(p[u], p[u], val, all); // self take care the below have no
}
else{ // not on the circle
update(p[f], p[f], val, all); // its father
update(sonL[f], sonR[f], val, all); // its father's son
if(in[f] > 1){ // its father is on the circle
update(p[ch[f][0]], p[ch[f][0]], val, all); // its father's left neighbor
update(p[ch[f][1]], p[ch[f][1]], val, all); // its father's fight neighbor
}
else // its father is not on the circle
update(p[fa[f]], p[fa[f]], val, all); // its father's father
}
update(sonL[u], sonR[u], val, all); // sons
update(ssonL[u], ssonR[u], val, all); // ssons
}
} LL query(int u, int k){ // the same as update
int f = fa[u];
LL ans = 0;
if(k == 0) return query(p[u], p[u], all);
else if(k == 1){
ans = query(sonL[u], sonR[u], all) + query(p[u], p[u], all);
if(in[u] == 1) ans += query(p[f], p[f], all);
else ans += query(p[ch[u][0]], p[ch[u][0]], all) + query(p[ch[u][1]], p[ch[u][1]], all);
}
else{
ans = query(sonL[u], sonR[u], all) + query(ssonL[u], ssonR[u], all);
if(in[u] > 1){
ans += query(p[u], p[u], all);
int vv[2], cnt = 0;
for(int i = 0; i < 2; ++i){
int v = ch[u][i];
ans += query(p[v], p[v], all);
ans += query(sonL[v], sonR[v], all);
for(int j = 0; j < 2; ++j){
int t = ch[v][j];
if(t == u || t == ch[u][i^1]) continue;
if(cnt == 1 && t == vv[0]) continue;
vv[cnt++] = t;
}
}
for(int i = 0; i < cnt; ++i)
ans += query(p[vv[i]], p[vv[i]], all);
}
else {
ans += query(p[f], p[f], all) + query(sonL[f], sonR[f], all);
if(in[f] > 1) ans += query(p[ch[f][0]], p[ch[f][0]], all) + query(p[ch[f][1]], p[ch[f][1]], all);
else ans += query(p[fa[f]], p[fa[f]], all);
}
}
return ans;
} int main(){
int T; cin >> T;
while(T--){
scanf("%d", &n);
init();
for(int i = 0; i < n; ++i){
int u, v;
scanf("%d %d", &u, &v);
addEdge(u, v);
addEdge(v, u);
}
praper();
scanf("%d", &m);
char op[10];
int u, k, d;
while(m--){
scanf("%s %d %d", op, &u, &k);
if(op[0] == 'M'){
scanf("%d", &d);
update(u, k, d);
}
else printf("%I64d\n", query(u, k));
}
}
return 0;
}

  

HDU 5957 Query on a graph (拓扑 + bfs序 + 树剖 + 线段树)的更多相关文章

  1. HDU 5957 Query on a graph

    HDU 5957 Query on a graph 2016ACM/ICPC亚洲区沈阳站 题意 \(N(N \le 10^5)\)个点,\(N\)条边的连通图. 有\(M \le 10^5\)操作: ...

  2. 2018.08.30 NOIP模拟 graph(dfs序/树剖+线段树)

    [描述] 给你一个图,一共有 N 个点,2*N-2 条有向边. 边目录按两部分给出 1. 开始的 n-1 条边描述了一颗以 1 号点为根的生成树,即每个点都可以由 1 号点 到达. 2. 接下来的 N ...

  3. 【HDU 5233】Tree chain problem (树形DP+树剖+线段树|树状数组)最大权不相交树链集

    [题目] Tree chain problem Problem Description Coco has a tree, whose vertices are conveniently labeled ...

  4. HDU 1611 敌兵布阵 / HRBUST 1794 敌兵布阵(线段树)

    HDU 1611 敌兵布阵 / HRBUST 1794 敌兵布阵(线段树) Description C国的死对头A国这段时间正在进行军事演习,所以C国间谍头子Derek和他手下Tidy又开始忙乎了.A ...

  5. HDU 4605 Magic Ball Game (在线主席树|| 离线 线段树)

    转载请注明出处,谢谢http://blog.csdn.net/ACM_cxlove?viewmode=contents    by---cxlove 题意:给出一棵二叉树,每个结点孩子数目为0或者2. ...

  6. 【8.26校内测试】【重构树求直径】【BFS模拟】【线段树维护DP】

    题目性质比较显然,相同颜色联通块可以合并成一个点,重新建树后,发现相邻两个点的颜色一定是不一样的. 然后发现,对于一条链来说,每次把一个点反色,实际上使点数少了2个.如下图 而如果一条链上面有分支,也 ...

  7. Wannafly挑战赛2_D Delete(拓扑序+最短路+线段树)

    Wannafly挑战赛2_D Delete Problem : 给定一张n个点,m条边的带权有向无环图,同时给定起点S和终点T,一共有q个询问,每次询问删掉某个点和所有与它相连的边之后S到T的最短路, ...

  8. Subtree Minimum Query CodeForces - 893F (线段树合并+线段树动态开点)

    题目链接:https://cn.vjudge.net/problem/CodeForces-893F 题目大意:给你n个点,每一个点有权值,然后这n个点会构成一棵树,边权为1.然后有q次询问,每一次询 ...

  9. hdu Minimum Inversion Number(逆序数的小知识与线段树)

    飞! 题解 首先,求逆序数对的思路: 1.得到整个数列后,从前往后扫,统计比a[i]小的,在a[i]后面的有多少个 这样做的话,应该是只有n2的暴力作法,没想到更好的方法 2.统计a[i]前面的,且比 ...

随机推荐

  1. vue深入了解组件——动态组件&异步组件

    一.在动态组件上使用 keep-alive 我们之前曾经在一个多标签的界面中使用 is 特性来切换不同的组件: <component v-bind:is="currentTabComp ...

  2. webserive学习记录2-cxf框架基础使用

    cxf是一个webservice的框架,类似的还有axis,下面说一下cxf的基本使用. 首先要下载cxf的文件,然后要在项目中引入jar包,当然也可以通过maven进行管理.我用的是最新的3.2.1 ...

  3. Boost.Coroutine2:学习使用Coroutine(协程)

    function(函数)routine(例程)coroutine (协程) 函数,例程以及协程都是指一系列的操作的集合. 函数(有返回值)以及例程(没有返回值)也被称作subroutine(子例程), ...

  4. dowhile

    public class TestDoWhile { /**do while 至少执行一次 先斩后奏 * 测试dowhile */ public static void main(String[] a ...

  5. oracle 基本信息

    查看Oracle是32位还是64位的方法: 方法一:使用sqlplus 64位: [oracle@qs-wg-db2 ~]$ sqlplus / as sysdba;   SQL*Plus: Rele ...

  6. 开始一个Android的appium实例

      1.查看Android的应用包名和activity的方法   (网上有很多种方法,这里应用的是查看日志的方法) CMD中输入>adb logcat -c                   ...

  7. tf.unstack()、tf.stack()

    tf.unstack 原型: unstack( value, num=None, axis=0, name='unstack' ) 官方解释:https://tensorflow.google.cn/ ...

  8. hbase概念

    1. 概述(扯淡~) HBase是一帮家伙看了Google发布的一片名为“BigTable”的论文以后,犹如醍醐灌顶,进而“山寨”出来的一套系统. 由此可见: 1. 几乎所有的HBase中的理念,都可 ...

  9. 利用python实现冒泡排序

    1.先生存一个随机数组成的list 2.然后进行排序,把大的元素放在后面,小的元素放在前面,最终实现从小到大排列 首先生存一个随机数组成的list import random # print(sys. ...

  10. js string 字符串

    mutil lines string 多行字符串, 由于多行字符串用\n写起来比较费事,所以最新的ES6标准新增了一种多行字符串的表示方法,用...表示,是单撇号, 不是单引号. 这是一个 多行 字符 ...